<?php

defined('BASEPATH') OR exit('No direct script access allowed');
  


class Contract extends CI_Controller {



	public function __construct()

	{

		parent::__construct();
		 if(empty($this->session->userdata('id')) ) {
      
		 
            $this->session->set_flashdata('flash_data', 'You don\'t have access!');
            redirect('login');
			 
        }

		$this->load->model('contract_model','contra');
		$this->load->model('payment_model','payment');
		$this->load->model('contractMeta_model','contract_meta');
		$this->load->model('contractActivity_model','activity');
        $this->load->model('position_model','position');
		$this->load->model('publication_model','pubs');
		$this->load->model('advertiser_model','adv');
		 $this->load->model('UserPrivileges_model','privilege');

		$this->load->helper('url'); // to load header footer or anyother url related links....

		$this->load->library('upload'); // to upload image

		$this->load->helper('directory'); //load directory helper ot show client image from upload folder 

		$this->load->library('form_validation');

		

	}



	public function index()

	{

	
$mydata['pubsInfo'] = $this->pubs->get_all();
		$this->load->view('contract/all_contract',$mydata);

	}

	

	public function ajax_list()

	{

	$list = $this->contra->get_datatables();
	$data = array();

		$no = $_POST['start'];
        $sn = 1;
		foreach ($list as $pos) {

			$no++;

			$row = array();
            $p_pubs = $this->pubs->get_by_id($pos->publication_id);
			$p_adv = $this->adv->get_by_id($pos->advertiser_id);
			 $p_position = $this->position->get_by_id($pos->position_id);
			 $row[] = $pos->reference_no;
			$row[] = $p_pubs->name;
			$row[] = $p_adv->name;
			$row[] = $p_position->title;
			//additional fields.....

			$row[] = '<a class="btn btn-icon-only yellow" href="'.base_url().'contract/details/'.$pos->id.'"><i class="fa fa-eye"></i></a><a class="btn btn-icon-only red" href="javascript:void()" title="Edit" onclick="delete_contract('."'".$pos->id."'".')"><i class="fa fa-trash"></i></a> ';

			$data[] = $row;
          $sn++;
		}



		$output = array(

						"draw" => $_POST['draw'],

						"recordsTotal" => $this->pubs->count_all(),

						"recordsFiltered" => $this->pubs->count_filtered(),

						"data" => $data,

						

				);

		//output to json format

		echo json_encode($output);

	}




	public function ajax_add()

	{
	
	$this->_validate();
	$post = $this->input->post();
	//print_r($post);
	//if(($post['no_year'])!='0') { // if any year posted	
	 $total_row = count($post['year']);       
         $metakey = '[';
 
        for($i=0; $i<$total_row; $i++){
        	
			  
						
   $metakey.= '{"year": "'.$post['year'][$i].'","January": "'.$post['jan'][$i].'","February": "'.$post['feb'][$i].'","March": "'.$post['mar'][$i].'","April": "'.$post['apr'][$i].'","May": "'.$post['may'][$i].'","June": "'.$post['jun'][$i].'","July": "'.$post['jul'][$i].'","August": "'.$post['aug'][$i].'","September": "'.$post['sep'][$i].'","October": "'.$post['oct'][$i].'","November": "'.$post['nov'][$i].'","December": "'.$post['dec'][$i].'"}';
 if($i<$total_row-1) {$metakey.=',';}
              }
			  $metakey.=']';

		$metavalue = $metakey;
		//}
/*
if(($post['no_year'])=='0') { // if no year posted	
	$thisYear = date('Y');
	$metavalue = '[{"year": "'.$thisYear.'","January": "0","February": "0","March": "0","April": "0","May": "0","June": "0","July": "0","August": "0","September": "0","October": "0","November": "0","December": "0"}]';
	    } 
		*/
// for additional offer section...		
if(($post['no_offer'])!='0') { // if any additional offer
$total_offer = count($post['item_name']);       
         $offer_metakey = '[';
 
        for($i=0; $i<$total_offer; $i++){
        		 
				
   $offer_metakey.= '{"item_name": "'.$post['item_name'][$i].'","item_value": "'.$post['item_value'][$i].'"}';
 if($i<$total_offer-1) {$offer_metakey.=',';}
              }
			  $offer_metakey.=']';

		$offer_metavalue = $offer_metakey;

		}
		if(($post['no_offer'])=='0') { // if no additional offer
		$offer_metavalue = '';
		
		 }
		
////////////////////////////////////		
		
		//print_r($metavalue);

		

		$data = array(
                'reference_no' => $this->input->post('reference_no'),
				'publication_id' => $this->input->post('publication_id'),

				'advertiser_id' => $this->input->post('advertiser_id'),

				'position_id' => $this->input->post('position_id'),

				'total_payment' => $this->input->post('total_payment'),
				'contract_date' => $this->input->post('contract_date'),

				'note' => $this->input->post('note'),
				'status' => 'active',
						

				);

		$insert = $this->contra->save($data); // execute the save function from user model

$metainfo = array('contract_id' => $insert, 'meta_key' => 'issue','meta_value' => $metavalue); // insert meta info according to the latest invoice id		
$insert_meta = $this->contract_meta->save($metainfo);

//for additional offers.
$offer_metainfo = array('contract_id' => $insert, 'meta_key' => 'offer','meta_value' => $offer_metavalue); // insert meta info according to the latest invoice id		
$insert_offer_meta = $this->contract_meta->save($offer_metainfo);

//for published status
$status_metainfo = array('contract_id' => $insert, 'meta_key' => 'published','meta_value' => $metavalue); // insert meta info according to the latest invoice id		
$insert_status_meta = $this->contract_meta->save($status_metainfo);

		echo json_encode(array('id'=>$insert,"status" => TRUE));

}

	public function custom_search($pub)
	 {
	 
	 //$data = $this->input->post('publication_id');
	 $mydata['pubsInfo'] = $this->pubs->get_all();
	 $mydata['searchInfo'] = $this->contra->custom_search_result($pub);
         $mydata['pubID'] = $pub;
        
	 $this->load->view('contract/contract_by_publication',$mydata);
	
	 }
public function published_issue($contractID) {
	$post = $this->input->post();
	
	$total_status = count($post['year']);       
         $status_metakey = '[';
 
        for($i=0; $i<$total_status; $i++){
        	
			
						
    $status_metakey.= '{"year": "'.$post['year'][$i].'","January": "'.$post['jan'][$i].'","February": "'.$post['feb'][$i].'","March": "'.$post['mar'][$i].'","April": "'.$post['apr'][$i].'","May": "'.$post['may'][$i].'","June": "'.$post['jun'][$i].'","July": "'.$post['jul'][$i].'","August": "'.$post['aug'][$i].'","September": "'.$post['sep'][$i].'","October": "'.$post['oct'][$i].'","November": "'.$post['nov'][$i].'","December": "'.$post['dec'][$i].'"}';
 if($i<$total_status-1) {$status_metakey.=',';}
              }
			  $status_metakey.=']';

		$status_metavalue = $status_metakey;
	$newMeta = array('meta_value'=>$status_metavalue);
	$this->contract_meta->update(array('contract_id' => $contractID,'meta_key'=>'published'),$newMeta);
	echo json_encode(array("status" => TRUE));
	
	  }

public function view($id=NULL)

	 {
        $myprev = $this->privilege->get_by_userid($this->session->userdata('id'));
	 $valid = $myprev->contract_crud;
	 if($valid == '0')  {
		 
            $this->session->set_flashdata('flash_data', 'You don\'t have access!');
            redirect('dashboard/no_access');
			//exit();
			 
        }
		else {
	 $contact_info['contractInfo'] = $this->contra->get_by_id($id);

	 

	 $this->load->view('contract/contract_details',$contact_info);

	 }
	  }


	public function contract_update($id=NULL)

	 {
 $data['advInfo'] = $this->adv->get_all();
	$data['posInfo'] = $this->position->get_all();
	 $data['pubsInfo'] = $this->pubs->get_all();
 $data['contraInfo'] = $this->contra->get_by_id($id);
	 

	 $this->load->view('contract/contract_profile',$data);

	 }

public function details($id=NULL)

	 {
 $data['contraInfo'] = $this->contra->get_by_id($id);
	 

	 $this->load->view('contract/contract_details',$data);

	 }
	 
public function summary($id=NULL)

	 {
 
 $data['contraInfo'] = $this->contra->get_by_id($id);
  

	 $this->load->view('contract/contract_summary',$data);

	 }

public function payment($id=NULL)

	 {
 
 $data['contraInfo'] = $this->contra->get_by_id($id);
 $data['paymentInfo'] = $this->payment->get_by_contract($id);  
 $data['total_paid'] = $this->payment->total_received($id);  

	 $this->load->view('contract/contract_payment',$data);

	 }

public function add_payment()

	{

		$this->_validate_payment();

		$data = array(
                'payment_for' => 'contract',
				'payment_key' => $this->input->post('contract_id'),

				'amount' => $this->input->post('amount'),

				'details' => $this->input->post('details'),

				'payment_date' => $this->input->post('payment_date'),

				

				);

		$insert = $this->payment->save($data); // execute the save function from user model

		//$this->authentic->add_to_group($this->input->post('group_id'), $insert);

		echo json_encode(array('id'=>$insert,"status" => TRUE));

	}

public function close_contract($id=NULL)

	{
	$data = array('status' => 'closed');
    $this->contra->update(array('id' => $id), $data);
   echo json_encode(array("status" => TRUE));

	}

public function cancel_contract($id=NULL)

	{
	$data = array('status' => 'cancelled');
    $this->contra->update(array('id' => $id), $data);
   echo json_encode(array("status" => TRUE));

	}
public function activate_contract($id=NULL)

	{
	$data = array('status' => 'active');
    $this->contra->update(array('id' => $id), $data);
   echo json_encode(array("status" => TRUE));

	}
public function activity($id=NULL)

	 {
         $contact_info['contractInfo'] = $this->contra->get_by_id($id);
	 $contact_info['activityInfo'] = $this->activity->get_by_contract($id);

	 

	 $this->load->view('contract/contract_activity',$contact_info);

	 }

	public function add_contract()

	 {
	   $myprev = $this->privilege->get_by_userid($this->session->userdata('id'));
	 $valid = $myprev->contract_crud;
	 if($valid == '0')  {
		 
            $this->session->set_flashdata('flash_data', 'You don\'t have access!');
            redirect('dashboard/no_access');
			//exit();
			 
        }
		else {
     $data['advInfo'] = $this->adv->get_all();
	$data['posInfo'] = $this->position->get_all();
	 $data['pubsInfo'] = $this->pubs->get_all();
 
	 $this->load->view('contract/add_contract',$data);

	 }

	 }


	public function ajax_update()

	{
	
	$this->_validate();
	
	$post = $this->input->post();
	//print_r($post);
	
	if(($post['no_year'])!='0') { // if any year posted
	
	 $total_row = count($post['year']);       
         $metakey = '[';
 
        for($i=0; $i<$total_row; $i++){
        	
   $metakey.= '{"year": "'.$post['year'][$i].'","January": "'.$post['jan'][$i].'","February": "'.$post['feb'][$i].'","March": "'.$post['mar'][$i].'","April": "'.$post['apr'][$i].'","May": "'.$post['may'][$i].'","June": "'.$post['jun'][$i].'","July": "'.$post['jul'][$i].'","August": "'.$post['aug'][$i].'","September": "'.$post['sep'][$i].'","October": "'.$post['oct'][$i].'","November": "'.$post['nov'][$i].'","December": "'.$post['dec'][$i].'"}';
 if($i<$total_row-1) {$metakey.=',';}
              }
			  $metakey.=']';

		$metavalue = $metakey;
		 }
	if(($post['no_year'])=='0') { // if no year posted	
	$thisYear = date('Y');
	$metavalue = '[{"year": "'.$thisYear.'","January": "0","February": "0","March": "0","April": "0","May": "0","June": "0","July": "0","August": "0","September": "0","October": "0","November": "0","December": "0"}]';
	    } 
	
		//print_r($metavalue);
   
		
// for additional offer section...	
if(($post['no_offer'])!='0') { // if any additional offer
$total_offer = count($post['item_name']);       
         $offer_metakey = '[';
 
        for($i=0; $i<$total_offer; $i++){
        		 
				
   $offer_metakey.= '{"item_name": "'.$post['item_name'][$i].'","item_value": "'.$post['item_value'][$i].'"}';
 if($i<$total_offer-1) {$offer_metakey.=',';}
              }
			  $offer_metakey.=']';

		$offer_metavalue = $offer_metakey;

		}
		if(($post['no_offer'])=='0') { // if no additional offer
		$offer_metavalue = '';
		
		 }
		
		$data = array(

				'reference_no' => $this->input->post('reference_no'),
				'publication_id' => $this->input->post('publication_id'),

				'advertiser_id' => $this->input->post('advertiser_id'),

				'position_id' => $this->input->post('position_id'),

				'total_payment' => $this->input->post('total_payment'),
				'contract_date' => $this->input->post('contract_date'),

				'note' => $this->input->post('note'),
				'status' => $this->input->post('status'),
			);

			

		$this->contra->update(array('id' => $this->input->post('id')), $data);

$newMeta = array('meta_value'=>$metavalue);
$existing = $this->contract_meta->get_by_meta($this->input->post('id'),'issue');	
if($existing) { $this->contract_meta->update(array('contract_id' => $this->input->post('id'),'meta_key'=>'issue'),$newMeta);	 }
/*
if(!$existing) {	
  if($newMeta) {
$metainfo = array('contract_id' => $this->input->post('id'), 'meta_key' => 'issue','meta_value' => $newMeta); // insert meta info according to the latest invoice id		
$insert_meta = $this->contract_meta->save($metainfo);
  }
 }
*/		
		
		
//for additional offers.

$OfferMeta = array('meta_value'=>$offer_metavalue);
$existing_offer = $this->contract_meta->get_by_meta($this->input->post('id'),'offer');	
$existing_published = $this->contract_meta->get_by_meta($this->input->post('id'),'published');	
if($existing_offer) { $this->contract_meta->update(array('contract_id' => $this->input->post('id'),'meta_key'=>'offer'),$OfferMeta); }
if(!$existing_offer) {	

$offer_metainfo = array('contract_id' => $this->input->post('id'), 'meta_key' => 'offer','meta_value' => $offer_metavalue); // insert meta info according to the latest invoice id		
$insert_offer_meta = $this->contract_meta->save($offer_metainfo);

 }
 if($existing_published) { $this->contract_meta->update(array('contract_id' => $this->input->post('id'),'meta_key'=>'published'),$newMeta); }
if(!$existing_published) {	

$published_metainfo = array('contract_id' => $this->input->post('id'), 'meta_key' => 'published','meta_value' => $newMeta); // insert meta info according to the latest invoice id		
$insert_published_meta = $this->contract_meta->save($published_metainfo);

 }
		
		echo json_encode(array("status" => TRUE));

	}



	public function ajax_delete($id)

	{
        $pub = $this->contra->get_by_id($id);
		$this->contra->delete_by_id($id);
			
		echo json_encode(array("status" => TRUE, "pubID"=>$pub->publication_id));

	}

// for dashboard statistics....
public function statistics($start,$end)
 {
 
 $data['adv_statistics']= $this->contra->advertiser_statistics($start,$end);
 $data['start_date'] = $start;
  $data['end_date'] = $end;
 $this->load->view('dashboard/advertiser_transaction',$data);
 
 }


	private function _validate()

	{

		$data = array();

		$data['error_string'] = array();

		$data['inputerror'] = array();

		$data['status'] = TRUE;

   



		if($this->input->post('reference_no') == '' )

		{

			$data['inputerror'][] = 'reference_no';

			$data['error_string'][] = 'Invalid Ref #';

			$data['status'] = FALSE;

		}
	
if($this->input->post('publication_id') == '0' )

		{

			$data['inputerror'][] = 'publication_id';

			$data['error_string'][] = 'select publication';

			$data['status'] = FALSE;

		}

if($this->input->post('advertiser_id') == '0' )

		{

			$data['inputerror'][] = 'advertiser_id';

			$data['error_string'][] = 'select advertiser';

			$data['status'] = FALSE;

		}

if($this->input->post('position_id') == '0' )

		{

			$data['inputerror'][] = 'position_id';

			$data['error_string'][] = 'select position';

			$data['status'] = FALSE;

		}


		if($data['status'] === FALSE)

		{

			echo json_encode($data);

			exit();

		}

	}

private function _validate_payment()

	{

		$data = array();

		$data['error_string'] = array();

		$data['inputerror'] = array();

		$data['status'] = TRUE;

   



		if($this->input->post('amount') == '' || !is_numeric($this->input->post('amount')) )

		{

			$data['inputerror'][] = 'amount';

			$data['error_string'][] = 'Invalid Amount';

			$data['status'] = FALSE;

		}
	
if($this->input->post('payment_date') == '' )

		{

			$data['inputerror'][] = 'payment_date';

			$data['error_string'][] = 'Invalid date';

			$data['status'] = FALSE;

		}


		if($data['status'] === FALSE)

		{

			echo json_encode($data);

			exit();

		}

	}

	

	



}

