<?php

defined('BASEPATH') OR exit('No direct script access allowed');



class Subscription extends CI_Controller {



	public function __construct()

	{

		parent::__construct();
		 if(empty($this->session->userdata('id')) ) {
      
		 
            $this->session->set_flashdata('flash_data', 'You don\'t have access!');
            redirect('login');
			 
        }

        $this->load->model('publication_model','pubs');
		$this->load->model('subscriptionType_model','type');
		$this->load->model('subscriber_model','person');
        $this->load->model('UserPrivileges_model','privilege');
		$this->load->helper('url'); // to load header footer or anyother url related links....

		$this->load->helper('directory'); //load directory helper ot show client image from upload folder 

		
		

	}



	public function index()

	{

	$mydata['pubsInfo'] = $this->pubs->get_all();

		$this->load->view('subscription/subscription_type',$mydata);

	}


	

public function custom_search($pub)
	 {
	 
	 $myprev = $this->privilege->get_by_userid($this->session->userdata('id'));
	 $valid = $myprev->subscription_crud;
	 $mydata['mypermission'] = $valid;
	 $mydata['pubsInfo'] = $this->pubs->get_all();
	 $mydata['searchInfo'] = $this->type->custom_search_result($pub);
         $mydata['pubID'] = $pub;
	 $this->load->view('subscription/type_by_publication',$mydata);
	//echo json_encode(array("status" => TRUE));
	 }
	 
public function type_list($pub)
   {
   //$pubID = $this->pubs->get_by_id($pub);
   $data = $this->type->custom_search_result($pub);
   echo json_encode($data);
   }

public function add_new()
 {
  $this->_validate_type();
	    
		$data = array(
		       'publication_id' => $this->input->post('publication_id'),
				'title' => $this->input->post('title'),
				'description' => $this->input->post('description'),
				'duration' => $this->input->post('duration'),
                                'fee' => $this->input->post('fee')
				
			);

		$insert = $this->type->save($data);

		echo json_encode(array("status" => TRUE));
 }

public function add_subscription_type()
	     {
		  $myprev = $this->privilege->get_by_userid($this->session->userdata('id'));
	 $valid = $myprev->subscription_crud;
	 if($valid == '0')  {
		 
            $this->session->set_flashdata('flash_data', 'You don\'t have access!');
            redirect('dashboard/no_access');
			//exit();
			 
        }
		else {
		$mydata['pubsInfo'] = $this->pubs->get_all();

		$this->load->view('subscription/add_subscription_type',$mydata);

	     } 
		 }
	
public function edit_subscription_type($id)

	{
          $myprev = $this->privilege->get_by_userid($this->session->userdata('id'));
	 $valid = $myprev->subscription_crud;
	 if($valid == '0')  {
		 
            $this->session->set_flashdata('flash_data', 'You don\'t have access!');
            redirect('dashboard/no_access');
			//exit();
			 
        }
		else {
		$data['typeInfo'] = $this->type->get_by_id($id);

		/*$data = array('id'=>$type_info->id, 
                      'publication_id' => $type_info->publication_id,
		               'title'=>$type_info->title,

					   'duration'=>$type_info->duration,
                                             'fee'=>$type_info->fee

					  );*/
					  
		
		 $data['pubsInfo'] = $this->pubs->get_all();
		
		$this->load->view('subscription/edit_subscription_type',$data);
		
        // echo json_encode($data);
		 }
	}
	
public function update_subscription_type()
	     {
	     $this->_validate_type();
	    
		$data = array(
		        'publication_id' => $this->input->post('publication_id'),
				'title' => $this->input->post('title'),
				'description' => $this->input->post('description'),
				'duration' => $this->input->post('duration'),
                                'fee' => $this->input->post('fee')
				
			);

		$this->type->update(array('id' => $this->input->post('id')), $data);

		echo json_encode(array("status" => TRUE,'pub_id'=>$this->input->post('publication_id')));

	     }	
public function delete_subscription_type($id)

	{
         $pub = $this->type->get_by_id($id);
		$this->type->delete_by_id($id);

		echo json_encode(array("status" => TRUE, "pubID"=>$pub->publication_id));

	}  

 //////////////// Reporting part //////////////////////
  
  public function reporting()

	{
	$myprev = $this->privilege->get_by_userid($this->session->userdata('id'));
	 $valid = $myprev->subscription_report;
	 if($valid == '0')  {
		 
            $this->session->set_flashdata('flash_data', 'You don\'t have access!');
            redirect('dashboard/no_access');
			//exit();
			 
        }
		else {
	//$this->load->model('UserPrevileges_model','allow');
	//$allowed = $this->allow->get_by_userid($this->session->userdata('id'));
    $mydata['pubsInfo'] = $this->pubs->get_all();
	$mydata['typeInfo'] = $this->type->get_all();
	//if(($allowed->reporting)=='1') {
	$this->load->view('subscription/all_reports',$mydata);
         //}
        // else { $this->load->view('dashboard'); }
	}
	 }
	
	public function list_by_month()

	{ 
	 $year = $this->input->post('year');
	 $month = $this->input->post('month');
	 $start = date("Y-".$month."-01", strtotime($year.'-'.$month.'-01'));// get start date from here
     $end = date("Y-".$month."-t", strtotime($start));
    
	
	// for single publication wise
	$pub = $this->input->post('publication_id');
	
	$list['singlePub'] = $pub;
	$list['start'] = $start;
	$list['end'] = $end;
	$list['year'] = $year;
	$list['month'] = $month;
	$list['pubsInfo'] = $this->pubs->get_by_id($pub);
	$this->load->view('subscription/reporting/monthly_report',$list);
	

	}

public function list_by_daterange()

	{ 
	 //$pub = $this->input->post('publication_id');
	 $start = $this->input->post('start_date');
	 $end = $this->input->post('end_date');
	 
	 // for single publication wise
	$pub = $this->input->post('publication_id');
	
    
	$list['pubsInfo'] = $this->pubs->get_by_id($pub);
	
	 $list['singlePub'] = $pub;
    $list['start'] = $start;
	$list['end'] = $end;
	//$list['pubsList'] = $this->pubs->get_all();
	$this->load->view('subscription/reporting/daterange_report',$list);
	}



public function list_by_year()

	{ 
	// $pub = $this->input->post('publication_id');
	 $year = $this->input->post('year');
	 $start = date("Y-01-01", strtotime($year.'-01-01'));// get start date from here
     $end = date("Y-12-t", strtotime($start));
	 
	  // for single publication wise
	$pub = $this->input->post('publication_id');
	
    
	$list['pubsInfo'] = $this->pubs->get_by_id($pub);
	
	 $list['singlePub'] = $pub;
	 
     $list['start'] = $start;
	$list['end'] = $end;
    $list['year'] = $year;
	//$list['pubsList'] = $this->pubs->get_all();
	$this->load->view('subscription/reporting/yearly_report',$list);
	}





//////////////////////////// validation functions /////////////////////
	private function _validate_type()
	{
		$data = array();
		$data['error_string'] = array();
		$data['inputerror'] = array();
		$data['status'] = TRUE;
		
		if($this->input->post('publication_id') == '0')
		{
			$data['inputerror'][] = 'publication_id';
			$data['error_string'][] = 'select publication';
			$data['status'] = FALSE;
		}

		if($this->input->post('title') == '')
		{
			$data['inputerror'][] = 'title';
			$data['error_string'][] = 'Title is required';
			$data['status'] = FALSE;
		}
		
		if($this->input->post('duration') == '' || !is_numeric($this->input->post('duration')) )
		{
			$data['inputerror'][] = 'duration';
			$data['error_string'][] = 'invalid duration';
			$data['status'] = FALSE;
		}
		
		if($this->input->post('fee') <> '' && !is_numeric($this->input->post('duration')) )
		{
			$data['inputerror'][] = 'fee';
			$data['error_string'][] = 'invalid fee';
			$data['status'] = FALSE;
		}
		
		
		
		
		if($data['status'] === FALSE)
		{
			echo json_encode($data);
			exit();
		}
	}
	

	



}
