<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Activity extends CI_Controller {

	public function __construct()
	{
		parent::__construct();
		
		$this->load->model('subscriberActivity_model','subs');
		$this->load->model('advertiserActivity_model','adv');
		$this->load->model('contractActivity_model','contra');
		$this->load->model('subscriber_model','person');
		$this->load->helper('url'); // to load header footer or anyother url related links....
		
		
	}

	public function index()
	{
	
		//$this->load->view('client/all_clients');
	}
	

	public function subscriber_add()
	{
		$this->_validate();
		$data = array(
		         'activity_for' => 'subscriber',
		        'object_id' => $this->input->post('object_id'),
				'activity_date' => $this->input->post('activity_date'),
				'activity_type' => $this->input->post('activity_type'),
				'details' => $this->input->post('activity_details'),
				'entry_by' => $this->session->userdata('id'),
					
			);
		$insert = $this->subs->save($data); // execute the save function from user model
		//$this->authentic->add_to_group($this->input->post('group_id'), $insert);
		echo json_encode(array('id'=>$insert,"status" => TRUE));
	}
	
	public function advertiser_add()
	{
		$this->_validate();
		$data = array(
		         'activity_for' => 'advertiser',
		        'object_id' => $this->input->post('object_id'),
				'activity_date' => $this->input->post('activity_date'),
				'activity_type' => $this->input->post('activity_type'),
				'details' => $this->input->post('activity_details'),
				'entry_by' => $this->session->userdata('id'),
					
			);
		$insert = $this->adv->save($data); // execute the save function from user model
		//$this->authentic->add_to_group($this->input->post('group_id'), $insert);
		echo json_encode(array('id'=>$insert,"status" => TRUE));
	}

public function contract_add()
	{
		$this->_validate();
		$data = array(
		         'activity_for' => 'contract',
		        'object_id' => $this->input->post('object_id'),
				'activity_date' => $this->input->post('activity_date'),
				'activity_type' => $this->input->post('activity_type'),
				'details' => $this->input->post('activity_details'),
				'entry_by' => $this->session->userdata('id'),
					
			);
		$insert = $this->contra->save($data); // execute the save function from user model
		//$this->authentic->add_to_group($this->input->post('group_id'), $insert);
		echo json_encode(array('id'=>$insert,"status" => TRUE));
	}
	
	
	
	public function ajax_delete($id)
	{
	   
		$this->subs->delete_by_id($id);
		echo json_encode(array("status" => TRUE));
	}


	private function _validate()
	{
		$data = array();
		$data['error_string'] = array();
		$data['inputerror'] = array();
		$data['status'] = TRUE;

		if($this->input->post('activity_type') == '')
		{
			$data['inputerror'][] = 'activity_type';
			$data['error_string'][] = 'Click on any Activity';
			$data['status'] = FALSE;
		}

		

		if($this->input->post('details') == '')
		{
			$data['inputerror'][] = 'details';
			$data['error_string'][] = 'Details is required';
			$data['status'] = FALSE;
		}

	}
	
//////////	

}
