<?php

defined('BASEPATH') OR exit('No direct script access allowed');
  


class Position extends CI_Controller {



	public function __construct()

	{

		parent::__construct();

		 if(empty($this->session->userdata('id')) ) {

            $this->session->set_flashdata('flash_data', 'You don\'t have access!');
            redirect('login');
			 
        }
        $this->load->model('position_model','position');
		$this->load->model('publication_model','pubs');
		$this->load->model('positionType_model','type');
		$this->load->model('positionColor_model','color');
      //$this->load->model('client_model','person');

		$this->load->helper('url'); // to load header footer or anyother url related links....

		$this->load->library('upload'); // to upload image

		$this->load->helper('directory'); //load directory helper ot show client image from upload folder 

		$this->load->library('form_validation');

		

	}



	public function index()

	{
    $data['pubsInfo'] = $this->pubs->get_all();
	
		$this->load->view('position/all_position',$data);

	}

	

	public function ajax_list()

	{

	$list = $this->position->get_datatables();
	$data = array();

		$no = $_POST['start'];
        $sn = 1;
		foreach ($list as $pos) {

			$no++;

			$row = array();
            $p_pubs = $this->pubs->get_by_id($pos->publication_id);
			$row[] = $p_pubs->name;
			$row[] = $pos->title;
			
			$row[] = $pos->dimension;
			$row[] = $pos->alignment;
			 
			 $p_color = $this->color->get_by_id($pos->paint_color);
			 $p_type = $this->type->get_by_id($pos->position_type);
			  $row[] = $p_type->title;
             $row[] = $p_color->title; 
			 // if($pos->status == '1') {$stat = '<mark class="green">Active</mark>';} if($pos->status == '0') {$stat = '<mark class="red">Inactive</mark>';}
          // $row[] = $stat;
			$row[] = '<a class="btn btn-icon-only yellow" id="view_position" onclick="view_pos('."'".$pos->id."'".')"><i class="fa fa-eye"></i></a><a class="btn btn-icon-only green" href="'.base_url()."position/edit/".$pos->id.'" title="Edit"><i class="fa fa-edit"></i></a><a class="btn btn-icon-only red" onclick="delete_position('."'".$pos->id."'".')"><i class="fa fa-trash"></i></a> ';

          
			$data[] = $row;
          $sn++;
		}



		$output = array(

						"draw" => $_POST['draw'],

						"recordsTotal" => $this->pubs->count_all(),

						"recordsFiltered" => $this->pubs->count_filtered(),

						"data" => $data,

						

				);

		//output to json format

		echo json_encode($output);

	}

public function custom_search($pub)
	 {
	 
	 //$data = $this->input->post('publication_id');
	 $mydata['pubsInfo'] = $this->pubs->get_all();
	 $mydata['searchInfo'] = $this->position->custom_search_result($pub);
         $mydata['pubID'] = $pub;
         $this->load->view('position/position_by_publication',$mydata);
	//echo json_encode(array("status" => TRUE));
	 }


	public function ajax_add()

	{

		$this->_validate();

		$data = array(
                'publication_id' => $this->input->post('publication_id'),
				'position_type' => $this->input->post('position_type'),

				'title' => $this->input->post('title'),

				'dimension' => $this->input->post('dimension'),

				'alignment' => $this->input->post('alignment'),

				'paint_color' => $this->input->post('paint_color'),
				'status' => $this->input->post('status'),

				);

		$insert = $this->position->save($data); // execute the save function from user model

		//$this->authentic->add_to_group($this->input->post('group_id'), $insert);

		echo json_encode(array('id'=>$insert,"status" => TRUE));
        $this->session->set_flashdata('message', 'Successfully Added.');
	}

	

	public function view($id=NULL)

	 {
 $data['pos_type'] = $this->type->get_all();
	$data['pos_color'] = $this->color->get_all();
	 $data['pubsInfo'] = $this->pubs->get_all();
 $data['posInfo'] = $this->position->get_by_id($id);
	 

	 $this->load->view('position/position_profile',$data);

	 }

public function edit($id=NULL)

	 {
	  
	 $data['pubsInfo'] = $this->pubs->get_all();
 	$data['pos_type'] = $this->type->get_all();
	$data['pos_color'] = $this->color->get_all();
	$data['posInfo'] = $this->position->get_by_id($id);

	 $this->load->view('position/edit_position',$data);

	 }

	public function add_position()

	 {
	   
    $data['pos_type'] = $this->type->get_all();
	$data['pos_color'] = $this->color->get_all();
	$data['pubsInfo'] = $this->pubs->get_all();
	 $this->load->view('position/add_position',$data);

	 

	 }


	public function ajax_update()

	{

		$this->_validate();

		$data = array(

				 'publication_id' => $this->input->post('publication_id'),
				'position_type' => $this->input->post('position_type'),

				'title' => $this->input->post('title'),

				'dimension' => $this->input->post('dimension'),

				'alignment' => $this->input->post('alignment'),

				'paint_color' => $this->input->post('paint_color'),
				'status' => $this->input->post('status'),

			);

			

		$this->position->update(array('id' => $this->input->post('id')), $data);


		echo json_encode(array("status" => TRUE));

	}



	public function ajax_delete($id)

	{

	  

		$this->position->delete_by_id($id);

		echo json_encode(array("status" => TRUE));

	}





	private function _validate()

	{

		$data = array();

		$data['error_string'] = array();

		$data['inputerror'] = array();

		$data['status'] = TRUE;

   
if($this->input->post('publication_id') == '0' )

		{

			$data['inputerror'][] = 'publication_id';

			$data['error_string'][] = 'select publication';

			$data['status'] = FALSE;

		}
		
		if($this->input->post('position_type') == '0' )

		{

			$data['inputerror'][] = 'position_type';

			$data['error_string'][] = 'select position type';

			$data['status'] = FALSE;

		}




		if($this->input->post('title') == '' )

		{

			$data['inputerror'][] = 'title';

			$data['error_string'][] = 'Invalid Name';

			$data['status'] = FALSE;

		}
	


		if($data['status'] === FALSE)

		{

			echo json_encode($data);

			exit();

		}

	}

	

	



}

