<?php

defined('BASEPATH') OR exit('No direct script access allowed');
  


class Publication extends CI_Controller {



	public function __construct()

	{

		parent::__construct();
   if(empty($this->session->userdata('id')) ) {
      
		 
            $this->session->set_flashdata('flash_data', 'You don\'t have access!');
            redirect('login');
			 
        }
		
 $this->load->model('publicationFrequency_model','freq');
		$this->load->model('publication_model','pubs');
		$this->load->model('publicationType_model','type');
		$this->load->model('publicationCategory_model','cat');
      $this->load->model('subscriber_model','person');
	   $this->load->model('UserPrivileges_model','privilege');
	 

		$this->load->helper('url'); // to load header footer or anyother url related links....

		$this->load->library('upload'); // to upload image
		

		$this->load->helper('directory'); //load directory helper ot show client image from upload folder 

		$this->load->library('form_validation');

		

	}



	public function index()

	{

	   $data['pubsInfo'] = $this->pubs->get_all();

		$this->load->view('publication/all_publication',$data);

	}

	

	public function ajax_list()

	{

	$list = $this->pubs->get_datatables();
	$data = array();

		$no = $_POST['start'];
        $sn = 1;
		foreach ($list as $pubs) {

			$no++;

			$row = array();
          //  $row[] = $sn;
		 
		 
		  
		  
			 if($pubs->cover_image) { $row[] = '<div class="profile-userpic"><img src="'.base_url()."uploads/publication/".$pubs->cover_image.'" alt="" class="img-responsive" style="max-width:50px;"></div> '; }
			 if(!$pubs->cover_image) { $row[] = '<div class="profile-userpic"><img src="'.base_url()."uploads/publication/publication-icon.png".'" alt="" class="img-responsive" style="max-width:50px;"></div> '; }
			

			$row[] = $pubs->name;
			
			  $pubFreqs = $this->freq->get_by_id($pubs->frequency);
			  if($pubFreqs) {$row[] = $pubFreqs->title;  }
			  if(!$pubFreqs) {$row[] = '';  }
			 
			 $active_subs = $this->person->get_by_pubid($pubs->id);
			
             $row[] = $active_subs->total_subscriber; // active subscriber will be calculated by another function... it will be added later...
			$row[] = $pubs->code_no;

             if($pubs->status == '1') {$stat = '<mark class="green">Active</mark>';} if($pubs->status == '0') {$stat = '<mark class="red">Inactive</mark>';}
           $row[] = $stat;
			$row[] = '<a class="btn btn-icon-only yellow" id="view_publication" onclick="view_pubs('."'".$pubs->id."'".')"><i class="fa fa-eye"></i></a><a class="btn btn-icon-only green" href="'.base_url()."publication/edit/".$pubs->id.'" title="Edit"><i class="fa fa-edit"></i></a> <a class="btn btn-icon-only red" href="javascript:void()" title="Delete" onclick="delete_publication('."'".$pubs->id."'".')"><i class="fa fa-trash"></i></a> ';

			$data[] = $row;
          $sn++;
		}



		$output = array(

						"draw" => $_POST['draw'],

						"recordsTotal" => $this->pubs->count_all(),

						"recordsFiltered" => $this->pubs->count_filtered(),

						"data" => $data,

						

				);

		//output to json format

		echo json_encode($output);

	}




	public function ajax_add()

	{

		$this->_validate();

		$data = array(

				'publication_type' => $this->input->post('publication_type'),

				'name' => $this->input->post('name'),

				'code_no' => $this->input->post('code_no'),

				'frequency' => $this->input->post('frequency'),

				'category' => $this->input->post('category'),

				'language' => $this->input->post('language'),

				'cover_image' => $this->input->post('cover_image'),
				'status' => $this->input->post('status'),

				);

		$insert = $this->pubs->save($data); // execute the save function from user model

		//$this->authentic->add_to_group($this->input->post('group_id'), $insert);

		echo json_encode(array('id'=>$insert,"status" => TRUE));

	}

	

	public function view($id=NULL)

	 {
	 
	  
	 $data['frequencyList'] = $this->freq->get_all();
 $data['pub_type'] = $this->type->get_all();
	$data['pub_cat'] = $this->cat->get_all();
	 $data['pubsInfo'] = $this->pubs->get_by_id($id);

	 

	 $this->load->view('publication/publication_profile',$data);

	 }
public function edit($id=NULL)

	 {
	  $myprev = $this->privilege->get_by_userid($this->session->userdata('id'));
	 $valid = $myprev->publication_crud;
	 if($valid == '0')  {
		 
            $this->session->set_flashdata('flash_data', 'You don\'t have access!');
            redirect('dashboard/no_access');
			//exit();
			 
        }
		else {
	  
	 $data['frequencyList'] = $this->freq->get_all();
 $data['pub_type'] = $this->type->get_all();
	$data['pub_cat'] = $this->cat->get_all();
	 $data['pubsInfo'] = $this->pubs->get_by_id($id);

	 

	 $this->load->view('publication/edit_publication',$data);

	 }
 }

public function ajax_upload() // upload for new transaction
	 {
	if(isset($_FILES["userFile"]) && $_FILES["userFile"]["error"]== UPLOAD_ERR_OK)
{
	############ Edit settings ##############
	$UploadDirectory	= 'uploads/publication/'; //specify upload directory ends with / (slash)
	##########################################
	
	/*
	Note : You will run into errors or blank page if "memory_limit" or "upload_max_filesize" is set to low in "php.ini". 
	Open "php.ini" file, and search for "memory_limit" or "upload_max_filesize" limit 
	and set them adequately, also check "post_max_size".
	*/
	
	//check if this is an ajax request
	if (!isset($_SERVER['HTTP_X_REQUESTED_WITH'])){
		die();
	}
	
	
	//Is file size is less than allowed size.
	if ($_FILES["userFile"]["size"] > 8145728000) { // max 5 MB
		die("<font color='#ff0000'>File size is too big!</font>");
	}
	
	//allowed file type Server side check
	switch(strtolower($_FILES['userFile']['type']))
		{
			//allowed file types
            
			 case 'image/png': 
			case 'image/gif': 
			case 'image/jpeg':
			case 'image/jpg': 
			case 'image/pjpeg':
			/*case 'text/plain':
			case 'text/html':
			case 'application/x-zip-compressed':
			case 'application/pdf':
			case 'application/msword':
			case 'application/vnd.ms-excel':
			case 'video/mp4':*/
			
				break;
			default:
				die('<font color="#ff0000">Unsupported File! </font>'); //output error
	}
	
	$File_Name          = strtolower($_FILES['userFile']['name']);
	$File_Ext           = substr($File_Name, strrpos($File_Name, '.')); //get file extention
	$Random_Number      = rand(0, 9999999999); //Random number to be added to name.
	$NewFileName 		= $Random_Number.$File_Ext; //new file name
	$targetPath = "uploads/publication/".$NewFileName;

	if(move_uploaded_file($_FILES['userFile']['tmp_name'], $targetPath))
	   {
	  	   
$response = $NewFileName;
echo $response;
	}
	
	else{
		die('<font color="#ff0000">error uploading File!</font>');
	}
	
}
else
{
	die('Something wrong with upload! Is "upload_max_filesize" set correctly?');
}
	

	 
 }	 

 public function delete_file($filename)
  {
  $absolutedir			= dirname(__FILE__);
//$absolutedir = str_replace('\controllers','',$absolutedir);
$upload_dir = str_replace('application/controllers','',$absolutedir); // for hosting server
$dir					= 'uploads/publication/'; //for hosting server
$serverdir				= $upload_dir.$dir;
  
 unlink($serverdir.$filename ); // remove the existing file


  }	
	 
	 
public function contact_avatar($id = NULL)
 {
 
header('Content-Type: application/json');
//ini_set('memory_limit','16M');

$error					= false;

$absolutedir			= dirname(__FILE__);
//$absolutedir = str_replace('\controllers','',$absolutedir);
$upload_dir = str_replace('application/controllers','',$absolutedir);
$dir					= '/uploads/contact/';
$serverdir				= $absolutedir.$dir;

$tmp					= explode(',',$_POST['data']);
$imgdata 				= base64_decode($tmp[1]);

$endx = explode('.',$_POST['name']);
$endxx = end($endx);
$extension				= strtolower($endxx);
$filename				= substr($_POST['name'],0,-(strlen($extension) + 1)).'.'.substr(sha1(time()),0,6).'-'.$id.'.'.$extension;

$handle					= fopen($serverdir.$filename,'w');
fwrite($handle, $imgdata);
fclose($handle);

$imagePath = $upload_dir.'uploads/contact/';
rename($serverdir.$filename,  $imagePath.$filename);


$response = array(
		"status" 		=> "success",
		"url" 			=> $dir.$filename.'?'.time(), //added the time to force update when editting multiple times
		"filename" 		=> $filename
);


if (!empty($_POST['original'])) {
	$tmp				= explode(',',$_POST['original']);
	$originaldata		= base64_decode($tmp[1]);
	$original			= substr($_POST['name'],0,-(strlen($extension) + 1)).'.'.substr(sha1(time()),0,6).'.original.'.$extension;

	$handle				= fopen($serverdir.$original,'w');
	fwrite($handle, $originaldata);
	fclose($handle);
	
	$response['original']	= $original;
}

$existing_photo = $this->pubs->get_by_id($id);
if(!empty($existing_photo->image_id)) {
 unlink($serverdir.$existing_photo->image_id ); // first remove the existing image....
   }
$myAvatar = array('image_id'=>$filename);
$this->pubs->update(array('id' => $id), $myAvatar);


print json_encode($response);
 
 
 }	 
	 


	public function fileUpload($id = NULL)

           {

    $imagePath = "uploads/";
	$existing_photo = $this->pubs->get_by_id($id);	
		   
		   unlink($imagePath.$existing_photo->image_id ); // first remove the existing image....

	$allowedExts = array("gif", "jpeg", "jpg", "png", "GIF", "JPEG", "JPG", "PNG");
	$temp = explode(".", $_FILES["img"]["name"]);
	$extension = end($temp);
	
	//Check write Access to Directory

	if(!is_writable($imagePath)){
		$response = Array(
			"status" => 'error',
			"message" => 'Can`t upload File; no write Access'
		);
		print json_encode($response);
		return;
	}
	
	if ( in_array($extension, $allowedExts))
	  {
	  if ($_FILES["img"]["error"] > 0)
		{
			 $response = array(
				"status" => 'error',
				"message" => 'ERROR Return Code: '. $_FILES["img"]["error"],
			);			
		}
	  else
		{
			
	      $filename = $_FILES["img"]["tmp_name"];
		  list($width, $height) = getimagesize( $filename );

 move_uploaded_file($filename,  $imagePath . $_FILES["img"]["name"]);
		  
		  

		  $response = array(
			"status" => 'success',
			"url" => $imagePath.$_FILES["img"]["name"],
			"width" => $width,
			"height" => $height
		  );
		  
		  
		  
		}
	  }
	else
	  {
	   $response = array(
			"status" => 'error',
			"message" => 'something went wrong, most likely file is to large for upload. check upload_max_filesize, post_max_size and memory_limit in you php.ini',
		);
	  }
	  
	  print json_encode($response);	
	  
	 

           }



	

	public function add_publication()

	 {
	 $myprev = $this->privilege->get_by_userid($this->session->userdata('id'));
	 $valid = $myprev->publication_crud;
	 if($valid == '0')  {
		 
            $this->session->set_flashdata('flash_data', 'You don\'t have access!');
            redirect('dashboard/no_access');
			//exit();
			 
        }
		else {
	  //$data['prev'] = $this->session->userdata('id'); //$myprev->publication_crud;
	 $data['frequencyList'] = $this->freq->get_all();
    $data['pub_type'] = $this->type->get_all();
	$data['pub_cat'] = $this->cat->get_all();
	 $this->load->view('publication/add_publication',$data);
}

 }


	public function ajax_update()

	{

		$this->_validate();

		$data = array(

				'publication_type' => $this->input->post('publication_type'),

				'name' => $this->input->post('name'),

				'code_no' => $this->input->post('code_no'),

				'frequency' => $this->input->post('frequency'),

				'category' => $this->input->post('category'),

				'language' => $this->input->post('language'),

				'cover_image' => $this->input->post('cover_image'),
				'status' => $this->input->post('status'),
			);

			

		$this->pubs->update(array('id' => $this->input->post('id')), $data);


		echo json_encode(array("status" => TRUE));

	}



	public function ajax_delete($id)

	{

	  

		$this->pubs->delete_by_id($id);

		echo json_encode(array("status" => TRUE));

	}

//////////////// Reporting part //////////////////////
  
  public function reporting()

	{
	
	 $myprev = $this->privilege->get_by_userid($this->session->userdata('id'));
	 $valid = $myprev->publication_report;
	 if($valid == '0')  {
		 
            $this->session->set_flashdata('flash_data', 'You don\'t have access!');
            redirect('dashboard/no_access');
			//exit();
			 
        }
		else {
	
    $mydata['pubsInfo'] = $this->pubs->get_all();
	$mydata['typeInfo'] = $this->type->get_all();
	//if(($allowed->reporting)=='1') {
	$this->load->view('publication/all_reports',$mydata);
         //}
        // else { $this->load->view('dashboard'); }
	}
	}
	
	public function list_by_month()

	{ 
	 $year = $this->input->post('year');
	 $month = $this->input->post('month');
	 $start = date("Y-".$month."-01", strtotime($year.'-'.$month.'-01'));// get start date from here
     $end = date("Y-".$month."-t", strtotime($start));
    
	
	// for single publication wise
	$pub = $this->input->post('publication_id');
	if($pub>0) {
     $paid = 'Paid';
     $comp = 'Complementary';
	//$list['subsInfo'] = $this->person->subscriber_by_daterange($pub,$start,$end,$type=NULL);
	$list['totalSubscriber'] = $this->person->total_subscribers($pub,$start,$end,$type=NULL);
	$list['totalPaid'] = $this->person->total_subscriber_by_category($pub,$start,$end,$paid,$type=NULL);
	$list['totalComplementary'] = $this->person->total_subscriber_by_category($pub,$start,$end,$comp,$type=NULL);
	$list['totalSubIncome'] = $this->person->total_income($pub,$start,$end,$type=NULL);
	$list['totalAdIncome'] = $this->person->total_adIncome($pub,$start,$end,$type=NULL);
    
	$list['pubsInfo'] = $this->pubs->get_by_id($pub);
	  }
	$list['singlePub'] = $pub;
	$list['start'] = $start;
	$list['end'] = $end;
	$list['year'] = $year;
	$list['month'] = $month;
	$list['pubsList'] = $this->pubs->get_all();
	$this->load->view('publication/reporting/monthly_report',$list);
	

	}

public function list_by_daterange()

	{ 
	 //$pub = $this->input->post('publication_id');
	 $start = $this->input->post('start_date');
	 $end = $this->input->post('end_date');
	 
	 // for single publication wise
	$pub = $this->input->post('publication_id');
	if($pub>0) {
     $paid = 'Paid';
     $comp = 'Complementary';
	//$list['subsInfo'] = $this->person->subscriber_by_daterange($pub,$start,$end,$type=NULL);
	$list['totalSubscriber'] = $this->person->total_subscribers($pub,$start,$end,$type=NULL);
	$list['totalPaid'] = $this->person->total_subscriber_by_category($pub,$start,$end,$paid,$type=NULL);
	$list['totalComplementary'] = $this->person->total_subscriber_by_category($pub,$start,$end,$comp,$type=NULL);
	$list['totalSubIncome'] = $this->person->total_income($pub,$start,$end,$type=NULL);
	$list['totalAdIncome'] = $this->person->total_adIncome($pub,$start,$end,$type=NULL);
    
	$list['pubsInfo'] = $this->pubs->get_by_id($pub);
	  }
	 $list['singlePub'] = $pub;
    $list['start'] = $start;
	$list['end'] = $end;
	$list['pubsList'] = $this->pubs->get_all();
	$this->load->view('publication/reporting/daterange_report',$list);
	}

public function list_by_month_and_type()

	{ 
	 $pub = $this->input->post('publication_id');
	 $year = $this->input->post('year');
	 $month = $this->input->post('month'); 
	 $type = $this->input->post('type');
	 $start = date("Y-".$month."-01", strtotime($year.'-'.$month.'-01'));// get start date from here
     $end = date("Y-".$month."-t", strtotime($start));
	
	$list['pubsInfo'] = $this->pubs->get_by_id($pub);
     $list['singlePub'] = $pub;
    $list['start'] = $start;
	$list['end'] = $end;
	$list['year'] = $year;
	$list['month'] = $month;
	
	$this->load->view('publication/reporting/typewise_monthly_report',$list);
	}



public function list_by_daterange_type()

	{ 
	  $pub = $this->input->post('publication_id');
	 $start = $this->input->post('start_date');
	 $end = $this->input->post('end_date');
	 $type = $this->input->post('type');
	 
     $list['pubsInfo'] = $this->pubs->get_by_id($pub);
     $list['singlePub'] = $pub;
    $list['start'] = $start;
	$list['end'] = $end;

	$this->load->view('publication/reporting/typewise_daterange_report',$list);
	}

public function list_by_year()

	{ 
	// $pub = $this->input->post('publication_id');
	 $year = $this->input->post('year');
	 $start = date("Y-01-01", strtotime($year.'-01-01'));// get start date from here
     $end = date("Y-12-t", strtotime($start));
	 
	  // for single publication wise
	$pub = $this->input->post('publication_id');
	if($pub>0) {
     $paid = 'Paid';
     $comp = 'Complementary';
	//$list['subsInfo'] = $this->person->subscriber_by_daterange($pub,$start,$end,$type=NULL);
	$list['totalSubscriber'] = $this->person->total_subscribers($pub,$start,$end,$type=NULL);
	$list['totalPaid'] = $this->person->total_subscriber_by_category($pub,$start,$end,$paid,$type=NULL);
	$list['totalComplementary'] = $this->person->total_subscriber_by_category($pub,$start,$end,$comp,$type=NULL);
	$list['totalSubIncome'] = $this->person->total_income($pub,$start,$end,$type=NULL);
	$list['totalAdIncome'] = $this->person->total_adIncome($pub,$start,$end,$type=NULL);
    
	$list['pubsInfo'] = $this->pubs->get_by_id($pub);
	  }
	 $list['singlePub'] = $pub;
	 
     $list['start'] = $start;
	$list['end'] = $end;
    $list['year'] = $year;
	$list['pubsList'] = $this->pubs->get_all();
	$this->load->view('publication/reporting/yearly_report',$list);
	}

public function list_by_year_type()

	{ 
	 $pub = $this->input->post('publication_id');
	 $year = $this->input->post('year');
	 $start = date("Y-01-01", strtotime($year.'-01-01'));// get start date from here
     $end = date("Y-12-t", strtotime($start));
	$list['pubsInfo'] = $this->pubs->get_by_id($pub);
     $list['singlePub'] = $pub;
	 $list['start'] = $start;
	$list['end'] = $end;
    $list['year'] = $year;
	
	$this->load->view('publication/reporting/typewise_yearly_report',$list);
	}







	private function _validate()

	{

		$data = array();

		$data['error_string'] = array();

		$data['inputerror'] = array();

		$data['status'] = TRUE;

   
    if($this->input->post('publication_type') == '0')

		{

			$data['inputerror'][] = 'publication_type';

			$data['error_string'][] = 'select type';

			$data['status'] = FALSE;

		}
	
	if($this->input->post('category') == '0')

		{

			$data['inputerror'][] = 'category';

			$data['error_string'][] = 'select category';

			$data['status'] = FALSE;

		}
	
	if($this->input->post('frequency') == '0')

		{

			$data['inputerror'][] = 'frequency';

			$data['error_string'][] = 'select frequency';

			$data['status'] = FALSE;

		}



		if($this->input->post('name') == '' )

		{

			$data['inputerror'][] = 'name';

			$data['error_string'][] = 'Invalid Name';

			$data['status'] = FALSE;

		}
	


		if($data['status'] === FALSE)

		{

			echo json_encode($data);

			exit();

		}

	}

	

	



}

