<?php
    defined('BASEPATH') OR exit('No direct script access allowed');
    class User extends CI_Controller 
    {
        public function __construct()
        {
            // if(!empty($this->session->userdata('logged_in'))){
            //     redirect('auth/user/home');
            // }
            if( isset( $_GET['session_id'] ) ) 
        	$_COOKIE[ $this->sess_cookie_name ] = $_GET['session_id'];
            parent::__construct();
            $this->load->model('subscriber_model','person');

	    $this->load->model('UserPrivileges_model','privilege');
            $this->load->helper('url');
            $this->load->library('form_validation');
            // $this->load->library('encryption');
            $this->load->library('encrypt');
            $this->load->library('session');
            $this->load->model('auth/user_model');
            $this->load->helper('auth/user_helper');
            $this->load->library('form_validation');
            // $this->load->model('user_model','person');
            $this->load->model('group_model','group');
            
            $this->load->model('UserPrivileges_model','priv');
            
            $this->load->helper('url');
            $this->load->library('upload'); // to upload image
        }


	    public function index()
	    {
	         
            if(!empty($this->session->userdata('logged_in')))
                redirect('auth/user/home');
            if(!empty($this->input->post()))
            {
               
                $this->form_validation->set_rules('email', 'Email', 'trim|required');
                $this->form_validation->set_rules('password', 'Password', 'trim|required');
                if ($this->form_validation->run() == FALSE)
                {
                    $this->load->view('auth/login');
                }
                else
                {
                     
                    $email = $this->input->post('email');
                    $password = $this->input->post('password');
                    $check_auth = $this->user_model->authenticate($email,$password);
                    if($check_auth)
                    {
                        redirect('auth/user/home');
                    }
                    else
                    {
                        redirect('auth/user');
                    }
                }
            }
            else
            {
                $this->load->view('auth/login');
            }
	    }
        

        public function view($id)
        {
            //$data['userInfo'] = $this->person->get_all();
            $this->load->model('user_model');
            $data['user'] = $this->user_model->get_by_id($id);
           // var_dump($data['user']);
            $this->load->view('auth/view_user',$data);
        }

        public function hidden()
        {
            
            $this->load->view('auth/hidden');
        }

        /*
         * Display user signup.
         */
        public function signup()
        {
            if(!empty($this->session->userdata('logged_in')))
                redirect('auth/user/home');
            if(!empty($this->input->post()))
            {
                $this->form_validation->set_rules('first_name', 'First Name', 'trim|required');
                $this->form_validation->set_rules('last_name', 'Last Name', 'trim|required');
                $this->form_validation->set_rules('email', 'Email', 'required|valid_email|is_unique[users.email]');
                $this->form_validation->set_rules('password', 'Password', 'trim|required|min_length[5]');
				$this->form_validation->set_rules('conf_password', 'Confirm Password', 'trim|required|matches[password]');


                if ($this->form_validation->run() == FALSE)
                {
                        $this->load->view('auth/signup');
                }
                else
                {
                    $input_data['first_name'] = $this->input->post('first_name',TRUE);	
                    $input_data['last_name'] = $this->input->post('last_name',TRUE);	
                    $input_data['email'] = $this->input->post('email',TRUE);
                    $input_data['username'] = $this->input->post('email',TRUE);
                    $input_data['password'] = $this->input->post('password',TRUE);
                    
                    $input_data['password'] = $this->encrypt->encode($input_data['password']);
                    
                    $input_data['user_activation_link'] = generate_random().time();
                    
                    //var_dump(generate_random());
                    $user_id = 0;
                    //var_dump($user_id);
                    $user_id = $this->user_model->update_user($input_data);


                    
                    if(!empty($user_id))
                    {
                       
                        $this->user_create_activation_sendmail($input_data);
                        $this->session->set_flashdata('success','Activation link has been sent to your email. Please check your mail & click on the \'Activation Link\' to activate your account.');
                        redirect('auth/user/hidden');
                    }
                    else
                    {
                        $this->session->set_flashdata('failure','Thre was a problem please try again later.');
                        redirect('auth/user/signup');
                    }
                }
            }
            else
            {
                $this->load->view('auth/signup');
            }
        }




        /*
        *   Home page when user succesfuly login
        */
        // public function home($email)
        public function home($email)
        {
            // echo $email;
            // exit();
            check_user_sess();
            $email = $this->session->userdata('logged_in')['email'];
            //var_dump($db);
            $this->load->model('subscriber_model');
            $email1 = $data['user'] = $this->subscriber_model->get_by_email($email);
            //var_dump($sub);
            
            if ($email1) {
                $this->load->view('auth/subscription_info', $data); 
            }else{
                $this->load->view('auth/home'); 
            }
        }

        public function success()
        {
          $this->load->view('auth/successful_message');
        }
        public function fail()
        {
            $this->load->view('auth/failed_msg');
        }
        public function cancel()
        {
            $this->load->view('auth/cancel_msg');
        }



        // sajid onlin
         public function payment($id)
        {
           // var_dump($id);
            // $email = $this->session->userdata('logged_in')['email'];
             //var_dump($email);
            $data['id'] = $id;
            $this->load->view('auth/payment', $data);   
        }
        public function payonline($id)
        {
            // check_user_sess();
            $this->load->model('subscriber_model');

            $data['user'] = $this->subscriber_model->get_by_id($id);
           // var_dump($data);
            
            $this->load->view('auth/pay_online',$data);   
        }


        // end

        

        public function edit($email)
        {
            check_user_sess();
            $email = $this->session->userdata('logged_in')['email'];
            //var_dump($db);
            $this->load->model('subscriber_model');
            $data['user'] = $this->subscriber_model->get_by_email($email);
            
                $this->load->view('auth/edit_subscription',$data); 
            
        }



        public function subscription($email)
        {
            $this->load->view('auth/subscription_info');
        }
        public function add_subscriber()
        {
            $usr = $this->session->userdata('logged_in')['user_id'];

        if (!empty($_POST)) {
            $name = $this->input->post('name');
            $company = $this->input->post('company');
            $designation = $this->input->post('designation');
            $phone = $this->input->post('phone');
            $email = $this->input->post('email');
            $house = $this->input->post('house');
            $area = $this->input->post('area');
            $city = $this->input->post('city');
            $zip = $this->input->post('zip');
            $country = $this->input->post('country');
            $type = $this->input->post('type');


            $data = array(
            'name' => $name,
            'company' => $company,
			'designation' => $designation,
			'phone' => $phone,
			'email' => $email,
			'house' => $house,
			'area' => $area,
			'city' => $city,
			'zip' => $zip,
			'country' => $country,
			'type' => $type,
            'publication_id' => '1',
            'status' => 'Pending',
            'user_id' => $usr            
            );

             $this->load->model('subscriber_model','sajid');
            //$insert = $this->sajid->save($data);
            $insert = $this->sajid->last_insert_id($data);

            // echo json_encode(array("status" => TRUE));

            //redirect('auth/user/home/');
            redirect('auth/user/payment/'.$insert);
            // echo json_encode(array('id'=>$insert,"status" => TRUE));
            // $this->load->view('auth/home', $data);   
        }

        
    }

        public function update_subscriber()
        {
        // $session_data = $this->session->all_userdata();
        $data = $this->load->model('subscriber_model', 'subscriber');
        $user_id = $this->session->userdata('logged_in')['user_id'];
        // var_dump($user_id);


        if (!empty($_POST)) {
            $name = $this->input->post('name');
            $company = $this->input->post('company');
            $designation = $this->input->post('designation');
            $phone = $this->input->post('phone');
            $email = $this->input->post('email');
            $house = $this->input->post('house');
            $area = $this->input->post('area');
            $city = $this->input->post('city');
            $zip = $this->input->post('zip');
            $country = $this->input->post('country');
            $type = $this->input->post('type');


            $data = array(
            'name' => $name,
            'company' => $company,
            'designation' => $designation,
            'phone' => $phone,
            'email' => $email,
            'house' => $house,
            'area' => $area,
            'city' => $city,
            'zip' => $zip,
            'country' => $country,
            'type' => $type,

                );

            

            $this->subscriber->update(array('user_id' => $user_id), $data);
            
             redirect('auth/user/home');
            // echo json_encode(array("status" => TRUE));
            // $insert = $this->sajid->save($data);
            // echo json_encode(array("status" => TRUE));
            // echo json_encode(array('id'=>$insert,"status" => TRUE));
            //$this->load->view('auth/payment', $data);   
        }
        
    }



        // end user subscriber 
        public function user_create_activation_sendmail($input_data)
        {
            $this->load->helper('auth/email_helper');
            $template_config = array(
                    'type' => 'send_activation_link',
                    'name' => ucwords($input_data['first_name']),
                    'email' => $input_data['email'],
                    'user_activation_link' => $input_data['user_activation_link']

            );
            $message_details = message_template($template_config);
            $headers = "From: Textiletoday (support@textiletoday.com.bd)";
            $mail_config = array('to' => $input_data['email'],
                    'subject' => 'User Activation Link',
                    'message' => $message_details,
                    'headers'=>$headers
                );
            send_email($mail_config);
        }
        public function active_user()
        {
            $random_string = $this->uri->segment(4);
            
            $user_details = $this->user_model->get_user_details_by_randomstring($random_string);
            if(!empty($user_details))
            {
                $status = $this->user_model->update_active_user($random_string);
                if($status == 1)
                {
                    $this->session->set_flashdata('success','Your account has been activated. Please login..');
                    redirect('auth/user');
                }
                else
                {
                    $this->session->set_flashdata('failure','There was a problem to activate your account. Try again later.');
                    redirect('auth/user');
                }
            }
            else
            {
                $this->session->set_flashdata('failure','Acount already activated. Please login..');
                redirect('auth/user');		
            }
        }

        
        /*
        *   Forget password code.
        */
        public function forget_password()
        {
            if(!empty($this->input->post()))
            {
                $this->form_validation->set_rules('email', 'Email', 'required|valid_email');
                if ($this->form_validation->run() == FALSE)
                {
                    $this->load->view('auth/forget_password');
                }
                else
                {
                    $email = $this->input->post('email');
                    $status = $this->user_model->check_email_exist($email);
                    if($status == 1)
                    {
                        $user_details = $this->user_model->get_user_details($email);
                        $data['forget_password_random_string'] = generate_random().time();
                        $data['email'] = $email;
                        $forget_password_status = $this->user_model->update_forget_password_random_string($data);
                        if($forget_password_status)
                        {
                            $email_data = array();
                            $email_data['email'] = $user_details['email'];
                            $email_data['first_name'] = $user_details['first_name'];
                            $email_data['last_name'] = $user_details['last_name'];
                            $email_data['reset_password_link'] = $data['forget_password_random_string'];
                            $this->user_forget_sendmail($email_data);
                            $this->session->set_flashdata('success','Please check your email. The password reset link has been sent your email.');
                            redirect('auth/user/forget_password');
                        }
                        else
                        {
                            $this->session->set_flashdata('failure','Thre was a problem please try again later.');
                            redirect('auth/user/forget_password');
                        }
                    }
                    else
                    {
                        $this->session->set_flashdata('failure','Email does not exist.');
                        redirect('auth/user/forget_password');
                    }
                }
            }
            else
            {
                if(!empty($this->session->userdata('logged_in')))
                    redirect('auth/user/home');
                $this->load->view('auth/forget_password');  
            }
            
        }

        /*
        *   Send Forget password mail.
        */
        public function user_forget_sendmail($email_data)
        {       
            $this->load->helper('auth/email_helper');
            $template_config = array(
                'type' => 'forget_password',
                'email' => $email_data['email'],
                'first_name' => $email_data['first_name'],
                'last_name' => $email_data['last_name'],
                'reset_password_link' => $email_data['reset_password_link'],

            );
            $message_details = message_template($template_config);

            $headers = "From: Bangladesh Textile Today (support@textiletoday.com.bd)";
            $mail_config = array('to' => $email_data['email'],
                                'subject' => 'Password Request',
                                'message' => $message_details,
                                'headers'=>$headers
                            );
            send_email($mail_config);
        }

        /*
        *   Reset password
        */
        public function reset_password()
        {
            $random_string = $this->uri->segment(4);
            $user_details = $this->user_model->get_user_details_reset_password($random_string);
            if(!empty($user_details))
            {
                if($random_string == $user_details['forget_password_random_string'])
                {
                    if($this->input->post())
                    {
                        $this->form_validation->set_rules('password', 'Password', 'trim|required|min_length[5]');
                        $this->form_validation->set_rules('conf_password', 'Confirm Password', 'trim|required|matches[password]');
                        if ($this->form_validation->run() == FALSE)
                        {
                            $data = array();
                            $data['random_string'] = $random_string;
                            $this->load->view('auth/password_reset',$data);
                        }
                        else
                        {
                            $password = $this->input->post('password');
                            $input_data['password'] = $this->encrypt->encode($password);
                            $input_data['email'] = $user_details['email'];
                            $input_data['reset_password_link'] = $random_string;
                            $status = $this->user_model->update_password($input_data);
                            if($status)
                            {
                                $this->user_model->update_reset_link($input_data['email']);
                                $this->session->set_flashdata('success','Password reset was successfully complete. Please login with new password.');
                                redirect('auth/user');  
                            }
                            else
                            {
                                $this->session->set_flashdata('failure','There was a problem. Please try again later..');
                                redirect('auth/user/forget_password'); 
                            }
                        }
                    }
                    else
                    {
                        $data = array();
                        $data['random_string'] = $random_string;
                        $this->load->view('auth/password_reset',$data);
                    }
                }
                else
                {
                    $this->session->set_flashdata('failure','Invalid request.');
                    redirect('auth/user/forget_password');     
                }
            }
            else
            {
                $this->session->set_flashdata('failure','Invalid request.');
                redirect('auth/user/forget_password');     
            }
        }

        /*
        *   Password change
        */
        public function change_password()
        {
            check_user_sess();
            if($this->input->post())
            {
                $this->form_validation->set_rules('password', 'Password', 'trim|required|min_length[5]');
                $this->form_validation->set_rules('conf_password', 'Confirm Password', 'trim|required|matches[password]');
                if ($this->form_validation->run() == FALSE)
                {
                    $this->load->view('auth/change_password');
                }
                else
                {
                    $password = $this->input->post('password');
                    $input_data['password'] = $this->encrypt->encode($password);
                    $input_data['email'] = $this->session->userdata('logged_in')['email'];
                    $status = $this->user_model->update_change_password($input_data);
                    if($status)
                    {
                        $this->session->set_flashdata('success','Password reset was successfully complete.');
                        redirect('auth/user/change_password');  
                    }
                    else
                    {
                        $this->session->set_flashdata('failure','There was a problem. Please try again later..');
                        redirect('auth/user/change_password'); 
                    }
                }
            }
            else
            {
                $this->load->view('auth/change_password');
            }
        }

        /*
        *   User logout 
        */
        public function logout()
        {
            check_user_sess();
            if($this->session->userdata('logged_in'))
            {
                $this->session->unset_userdata('logged_in');
                $this->session->sess_destroy();
                redirect('auth/user');
            }
        }
	}

