<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Advertiser_model extends CI_Model {

	var $table = 'advertiser';
	var $column = array('name','email'); //set column field database for order and search
	var $order = array('id' => 'desc'); // default order 

	public function __construct()
	{
		parent::__construct();
		$this->load->database();
		
	}

	private function _get_datatables_query()
	{
		
		$this->db->from($this->table);
		
		$i = 0;
	
		foreach ($this->column as $item) // loop column 
		{
			if($_POST['search']['value']) // if datatable send POST for search
			{
				
				if($i===0) // first loop
				{
					$this->db->group_start(); // open bracket. query Where with OR clause better with bracket. because maybe can combine with other WHERE with AND. 
					$this->db->like($item, $_POST['search']['value']);
				}
				else
				{
					$this->db->or_like($item, $_POST['search']['value']);
				}

				if(count($this->column) - 1 == $i) //last loop
					$this->db->group_end(); //close bracket
			}
			$column[$i] = $item; // set column array variable to order processing
			$i++;
		}
		
		if(isset($_POST['order'])) // here order processing
		{
			$this->db->order_by($column[$_POST['order']['0']['column']], $_POST['order']['0']['dir']);
		} 
		else if(isset($this->order))
		{
			$order = $this->order;
			$this->db->order_by(key($order), $order[key($order)]);
		}
	}

	function get_datatables()
	{
		$this->_get_datatables_query();
		if($_POST['length'] != -1)
		$this->db->limit($_POST['length'], $_POST['start']);
		
		$query = $this->db->get();
		return $query->result();
	}
	
	public function get_all()
	{
		$this->db->from($this->table);
		// $this->db->where('status = "active"');
		$query = $this->db->get();
// 
		return $query->result();
	}
	

	function count_filtered()
	{
		$this->_get_datatables_query();
		$query = $this->db->get();
		return $query->num_rows();
	}

	public function count_all()
	{
		$this->db->from($this->table);
		
		return $this->db->count_all_results();
	}

	public function get_by_id($id)
	{
		$this->db->from($this->table);
		$this->db->where('id',$id);
		$query = $this->db->get();

		return $query->row();
	}
	
public function totalAdvertiser()
	{
		$pub_query = $this->db->query('select count(id) as totalAdv from advertiser where status="active"');
		
		$query = $pub_query->row();
		return $query->totalAdv;
	}

public function weeklyAdvertiser()
	{
	$start = date('Y-m-d',strtotime('-7 days'));
	$end = date('Y-m-d');
		$pub_query = $this->db->query('select count(id) as weekly_advertiser from advertiser where status="active" and start_date between"'.$start.'" and "'.$end.'"');
		
		$query = $pub_query->row();
		return $query->weekly_advertiser;
	}

public function advertisement_revenue()
	{
		$pub_query = $this->db->query("SELECT sum( total_payment ) AS advRevenue FROM advertisement_contract");
		
		$query = $pub_query->row();
		return $query->advRevenue;
	}

public function weeklyRevenue()
	{
	$start = date('Y-m-d',strtotime('-7 days'));
	$end = date('Y-m-d');
		$pub_query = $this->db->query("SELECT sum( amount ) AS weekly_revenue FROM payment where payment_for = 'contract' and payment_date between '".$start."' and '".$end."'");
		
		$query = $pub_query->row();
		return $query->weekly_revenue;
	}

public function custom_search_result($mystring){
        $this->db->from($this->table);
$this->db->where('publication_id = '.$mystring); // deposit = ac_from(0)		

		$query = $this->db->get();
		return $query->result();

    }


public function monthly_growth($year,$month)
 {
 //$start = date("Y-".$month."-01", strtotime($year.'-'.$month.'-01'));// get start date from here
 //$end = date("Y-".$month."-t", strtotime($start));
 $start = '2016-11-01'; 
  $end = '2016-11-10'; 
 $adv_query = "select count(id) as totalAdv from advertiser where start_date between '".$start."' and '".$end."' and status='active'";
  $adv = $adv_query->row();
 
 return $adv->totalAdv;
 }


public function top_advertiser($year)
  {
   $start = date("Y-01-01", strtotime($year.'-01-01'));// get start date from here
     $end = date("Y-12-t", strtotime($year));
     
//$adv_query = $this->db->query( "SELECT payment_key as topAdv, SUM( amount ) AS TOP FROM payment WHERE payment_for =  'contract' AND payment_date BETWEEN  '".$start."' AND  '".$end."' GROUP BY topAdv ORDER BY TOP DESC"); 

$adv_query = $this->db->query( "SELECT payment_key as topAdv,  amount  AS TOP FROM payment WHERE payment_for =  'contract' AND payment_date BETWEEN  '".$start."' AND  '".$end."' ORDER BY id DESC LIMIT 5"); 



$adv =  $adv_query->result();
  return $adv;
  }



	public function save($data)
	{
		$this->db->insert($this->table, $data);
		return $this->db->insert_id();
	}

	public function update($where, $data)
	{
		$this->db->update($this->table, $data, $where);
		return $this->db->affected_rows();
	}
	
	public function delete_by_id($id)
	{
		$this->db->where('id', $id);
		$this->db->delete($this->table);
	}
	
	
	

}
