<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Payment_model extends CI_Model {

	var $table = 'payment';
	//var $column = array('title','alignment'); //set column field database for order and search
	var $order = array('id' => 'desc'); // default order 

	public function __construct()
	{
		parent::__construct();
		$this->load->database();
		
	}

	
	public function get_all()
	{
		$this->db->from($this->table);
		
		$query = $this->db->get();

		return $query->result();
	}
	
	

	function count_filtered()
	{
		$this->_get_datatables_query();
		$query = $this->db->get();
		return $query->num_rows();
	}

	public function count_all()
	{
		$this->db->from($this->table);
		
		return $this->db->count_all_results();
	}

	public function get_by_id($id)
	{
		$this->db->from($this->table);
		$this->db->where('id',$id);
		$query = $this->db->get();

		return $query->row();
	}

public function get_by_contract($id)
	{
		$this->db->from($this->table);
		$this->db->where('payment_for = "contract" and payment_key=',$id);
		$query = $this->db->get();

		return $query->result();
	}

public function total_received($id) // for contract payment
	{
	 $pay_query = $this->db->query("select sum(amount) as totalReceived from payment where payment_for = 'contract' and payment_key='".$id."'");
	 $total = $pay_query->row();
	 return $total->totalReceived;
	}

public function get_by_subscription($id)
	{
		$this->db->from($this->table);
		$this->db->where('payment_for = "subscription" and payment_key=',$id);
		$query = $this->db->get();

		return $query->result();
	}





	public function save($data)
	{
		$this->db->insert($this->table, $data);
		return $this->db->insert_id();
	}

	public function update($where, $data)
	{
		$this->db->update($this->table, $data, $where);
		return $this->db->affected_rows();
	}
	
	public function delete_by_id($id)
	{
		$this->db->where('id', $id);
		$this->db->delete($this->table);
	}
	
	
	

}
