<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Settings_model extends CI_Model {

	var $table = 'settings';
	//var $column = array('id','receipt_id','meta_key','meta_value'); //set column field database for order and search
	var $order = array('id' => 'desc'); // default order 

	public function __construct()
	{
		parent::__construct();
		$this->load->database();
	}

	public function count_all()
	{
		$this->db->from($this->table);
		return $this->db->count_all_results();
	}

	public function get_by_id($id)
	{
		$this->db->from($this->table);
		$this->db->where('id',$id);
		$query = $this->db->get();

		return $query->row();
	}
	
	
	
	public function get_by_meta($mkey) // get the invoices meta according to the receipt_id and meta_key
	{
		$this->db->from($this->table);
		$this->db->where('meta_key',$mkey);
     
		$query = $this->db->get();

		//return $query->result(); // show all resutl...
		return $query->row();
	}

public function get_by_gateway() // get the invoices meta according to the receipt_id and meta_key
	{
		$this->db->from($this->table);
		$this->db->where('meta_key = "paypal" OR meta_key = "stripe" OR meta_key = "2co" OR meta_key = "cheque" OR meta_key = "bank"');
     
		$query = $this->db->get();

		//return $query->result(); // show all resutl...
		return $query->result();
	}

	public function save($data)
	{
		$this->db->insert($this->table, $data);
		return $this->db->insert_id();
	}

	public function update($where, $data)
	{
		$this->db->update($this->table, $data, $where);
		return $this->db->affected_rows();
	}

	public function delete_by_id($id)
	{
		$this->db->where('id', $id);
		$this->db->delete($this->table);
	}


}